function [x,fval]=true_m(J,s,A,T,options)


function F = fun_true_m(mu)

%%% trade barriers      
Ts=T.^(1-s);

for j=1:J
mmu(j,1)=mu(j);
end    

mmu1=mmu.^(s/(1-s));
mmu2=mmu.^(1/(1-s));

Sn=(Ts'*mmu);
Zn=Ts*(mmu2.*A./Sn);

F=mmu1.*A-Zn;

end  


x0 =(1/J)*ones(J,1);           % Make a starting guess at the solution
%x0 =A*ones(J,1);           % Make a starting guess at the solution

[x,fval] = fsolve(@fun_true_m,x0,options);  % Call optimizer
end