mata:

function within  (real vector y, real matrix Qbb )
{ 
yqbb=Qbb*y
return(yqbb)
printf("done yqbb \n")
}

function withinest (real vector y, real matrix Qbb, real matrix Z )
{ 
Zbb=(Qbb*Z, J(rows(Z),1,1))
b=invsym(Zbb'*Zbb)*Zbb'*y
return(b)
printf("done b \n")
}
 
function predict  (real matrix Qbb, matrix Qbvols, real matrix Qw,
	real matrix Z, real matrix Z0, 
	real matrix sp, real matrix sp_w, real matrix sp_bbt, real matrix D, 
	real matrix b_w,
	real matrix za_avw, real matrix za_bvols,  real matrix za_bb, 
	real matrix za_w, real matrix za_ww, 
	real matrix zacf_avw, real matrix zacf_bvols,  real matrix zacf_bb, 
	real matrix zacf_w, real matrix zacf_ww,
	real matrix thm , real matrix thx, real matrix thxx, 
	real matrix y, real matrix yi ,  real matrix yj,  real vector mu )
{ 

printf("begin  prediction\n")
/*hx=exp(mu*(1/(1-$s)) ):*thxx*/
hx=thxx
printf("done hx first step \n")
hx=hx/sum(hx)
hhx=hx
printf("done hx second step \n")
hm=hx:*(thm:/thxx)
printf("done hm first step \n")
hx=hx[1..$b-1,1]
printf("done hx and hm \n")

H12=(1/(1-$s))*(diag(hm)-hm*hm')
H12=H12[1..$b,1..$b-1]
H22=(1/(1-$s))*(diag(hx)-hx*hx')
H11=J($b,$b,0);
H21=J($b-1,$b,0)
H1=(H11,H12 )
H2=(H21,H22 )
(rows(hx), cols(hm))
/*
(rows(H1), cols(H1))
(rows(H2), cols(H2))
*/
printf("done H1 and H2 \n")

H=(H11,H12 \ H21, H22)
/*
(rows(H11), cols(H11))
(rows(H12), cols(H12))
(rows(H21), cols(H21))
(rows(H22), cols(H22))
(rows(H), cols(H))*/

b=(thm:/thxx)
B1=diag(b)
(rows(B1), cols(B1))
printf("done B1 \n")
B2=I($b)
B2=B2[1..$b-1,.]
(rows(B2), cols(B2))
printf("done B2 \n")
B=(B1\B2)
(rows(B), cols(B))
printf("done B \n")
K=(1/(1-$s))*(diag(hhx)-hhx*hhx')
K=K[1..$b,1..$b-1]
(rows(K), cols(K))
printf("done K \n")
H1=(H11\H21)
H2=B*K
H1=(H1,H2)
(rows(H1), cols(H1))
(rows(H), cols(H))
(norm(H-H1), norm(D'*sp-B*hhx))
H=H1
printf("done H new \n")
printf("done H \n")

lspt=log(sp)
lthxm=log(yi)+log(yj)
lsp_bbt=log(sp_bbt)
lsp_w=log(sp_w)
ybvols=lspt-lthxm
ybb=lspt-log(sp_bbt)
e=J(rows(za_bb),1,1)
(mean(lthxm), mean(lsp_bbt), mean(lsp_w))
printf("done basline predictions \n")

withinest(ybvols, Qbvols, Z)
c_bvols=( mean(lspt)- mean(Qbvols*za_bvols+log(yi)+log(yj)) ):*e
yp_bvols=  (Qbvols*za_bvols  +c_bvols+log(yi)+log(yj) )
ypcf_bvols=(Qbvols*zacf_bvols+c_bvols+log(yi)+log(yj) )
r_bvols=lspt-yp_bvols
(mean(za_bvols),mean(zacf_bvols))
(mean(lspt-yp_bvols), mean(lspt) , mean(yp_bvolsb), mean(ypcf_bvols), mean(c_bvols), variance(r_bvols))
printf("done linear prediction bvols \n")

withinest( ybb , Qbb, Z)
c_bb=(mean(lspt) - mean(Qbb*za_bb + log(sp_bbt))  ):*e
yp_bb=  (Qbb*za_bb   +c_bb + log(sp_bbt) )
ypcf_bb=(Qbb*zacf_bb +c_bb + log(sp_bbt) )
r_bb=lspt-yp_bb
(mean(za_bb),mean(zacf_bb))
(mean(lspt-yp_bb), mean(lspt), mean(yp_bb), mean(ypcf_bb), mean(c_bb),variance(r_bb))
printf("done linear prediction bb \n")

c_bvols_w=(mean(lspt)- mean(Qbvols*za_w+log(yi)+log(yj) )  ) :*e
yp_bvols_w=  (Qbvols*za_w  +c_bvols_w+log(yi)+log(yj) )
ypcf_bvols_w=(Qbvols*zacf_w+c_bvols_w+log(yi)+log(yj) )
r_bvols_w=lspt-yp_bvols_w
(mean(za_w),mean(zacf_w))
(mean(lspt-yp_bvols_w), mean(lspt), mean(yp_bvols_w), mean(ypcf_bvols_w), mean(c_bvols_w),variance(r_bvols_w))
printf("done linear prediction bvols_w \n")

/*
c_bb=(mean(lspt)- mean(Qbb*za_w+log(sp_w))  ) :*e
yp_bb_w=  (Qbb*za_w  +c_bb+log(sp_w) )
ypcf_bb_w=(Qbb*zacf_w+c_bb+log(sp_w) )
(mean(lspt), mean(yp_bb_w), mean(ypcf_bb_w), mean(c_bb))
*/

c_bb_w=( mean(lspt)- mean(Qbb*za_w+log(sp_bbt)) ):*e
yp_bb_w=   (Qbb*za_w  +c_bb_w + log(sp_bbt) )
ypcf_bb_w= (Qbb*zacf_w+c_bb_w + log(sp_bbt) )
r_bb_w=lspt-yp_bb_w
(mean(za_w),mean(zacf_w))
(mean(lspt-yp_bb_w), mean(lspt), mean(yp_bb_w), mean(ypcf_bb_w), mean(c_bb_w),variance(r_bb_w) )
printf("done linear prediction bb_w \n")

c_bb_ww=(mean(lspt)- mean(Qbb*za_ww+log(sp_bbt)) ):*e
yp_bb_ww= (Qbb*za_ww    +c_bb_ww+log(sp_bbt)   )
ypcf_bb_ww=(Qbb*zacf_ww +c_bb_ww+log(sp_bbt)   )
r_bb_ww=lspt-yp_bb_ww
(mean(za_ww),mean(zacf_ww))
(mean(lspt-yp_bb_ww), mean(lspt), mean(yp_bb_ww), mean(ypcf_bb_ww), mean(c_bb_ww),variance(r_bb_ww))
printf("done linear prediction bb_ww  \n")

Gw=diag(sp_w)
Qww=I($b^2)- D*invsym(D'*Gw*D)*D'*Gw
Qw=I($b^2)- D*invsym(D'*D)*D'

/* za_w  does not make sense approximation at za_w as delta za_w=0 
Q_ww vs Qw*/
c_w=(mean(lspt)- mean(Qw*za_w*0+log(sp_w)) ):*e
yp_w=  (Qw*za_w*0   +c_w +log(sp_w)  )  
ypcf_w=(Qw*zacf_w +c_w +log(sp_w)  )
r_w=lspt-yp_w
(mean(lspt-yp_w), mean(lspt), mean(yp_w),mean(ypcf_w), mean(c_w),variance(r_w) ) 
printf("done linear prediction Qw true theta \n")

/* This assumes that za_ww parameters are used and aproximation point is based on za_ww 
Gw=diag(sp_w)
Qww=I($b^2)- D*invsym(D'*Gw*D)*D'*Gw
*/ 

yp_ww_w=  (Qww*za_ww*0  +log(sp_w) )
ypcf_ww_w=(Qww*zacf_ww +log(sp_w) )

lsp_w=log(sp_w)  
c_ww_w=(mean(lspt-yp_ww_w)):*e
c_ww_w=(mean(lspt-yp_ww_w)):*e
yp_ww_w=yp_ww_w+c_ww_w
ypcf_ww_w=ypcf_ww_w+c_ww_w
r_ww_w=lspt-yp_ww_w

test=Qww*(za_ww-zacf_ww) 
(mean(test ), mean(yp_ww_w-ypcf_ww_w) )
(mean(lspt-yp_ww_w), mean(lspt), mean(yp_ww_w), mean(ypcf_ww_w), mean(c_ww_w),variance(r_ww_w) )
printf("done linear prediction QWW true theta \n")

Gw=diag(sp_w)
Qww=I($b^2)- D*invsym(D'*Gw*D)*D'*Gw
Qwwge=I($b^2)- D*invsym(D'*Gw*D-H)*D'*Gw
(norm(D'*Gw*D-(D'*Gw*D-H)), norm(Qwwge-Qww))
printf("Done Qwwge \n")

c_w=(mean(lspt)-  mean(Qwwge*za_w+ log(sp_w)) ):*e
c_ww= (mean(lspt) - mean( Qwwge*za_ww+log(sp_w))  ):*e 
ypcf_wwge_w=(Qwwge*zacf_w +c_w  +log(sp_w) )
ypcf_wwge=(Qwwge*zacf_ww  +c_ww+ log(sp_w) )
printf("done ge prediction wwge \n")
r_wwge=lspt-ypcf_wwge
(mean(lspt-ypcf_wwge), mean(lspt), mean(ypcf_wwge_w), mean(ypcf_wwge), mean(c_w),mean(c_ww),variance(r_wwge) )
printf("done ge prediction wwge \n")

/*counterfactual changes */
dypcf_bvols=-Qbvols*(za_bvols-zacf_bvols)
(mean(dypcf_bvols),mean(za_bvols),mean(zacf_bvols), mean(za_bvols)-mean(zacf_bvols))
printf("done dypcf_bb \n")

dypcf_w=-Qww*(za_w-zacf_w)
(mean(dypcf_w),mean(za_w),mean(zacf_w), mean(za_w)-mean(zacf_w))
printf("done dypcf_ww \n")

dypcf_wwge= -Qwwge*(za_w-zacf_w)
(mean(dypcf_wwge),mean(za_w),mean(zacf_w), mean(za_w)-mean(zacf_w))
printf("done dypcf_wwge \n")

dypcf_bvols_w=-Qbvols*(za_w-zacf_w)
( mean(dypcf_bvols_w),mean(za_w), mean(zacf_w), mean(za_w)-mean(zacf_w) )
printf("done dypcf_bvols_w \n")

dypcf_ww_w= -Qww*(za_ww-zacf_ww) 
(mean(dypcf_ww_w), mean(za_ww),mean(zacf_ww),mean(za_ww)-mean(zacf_ww))
printf("done dypcf_ww_w \n")

dypcf_wwge_w= -Qwwge*(za_ww-zacf_ww) 
(mean(dypcf_wwge_w),mean(za_ww),mean(zacf_ww), mean(za_ww)-mean(zacf_ww))
printf("done dypcf_wwge_w \n")

/* collect results in dypcf*/
dypcf=(dypcf_bvols, dypcf_w, dypcf_wwge, dypcf_bvols_w, dypcf_ww_w, dypcf_wwge_w)
printf("done predict cf change  \n")

st_store(. , "yp_bb", yp_bb)
st_store(. , "yp_bvols", (yp_bvols))
printf("done store 1 \n")
st_store(. , "yp_bb_ww", yp_bb_ww)
printf("done store 2 \n")
st_store(. , "ypcf_bvols", (ypcf_bvols))
st_store(. , "ypcf_bb", (ypcf_bb))
printf("done store 3 \n")
st_store(. , "ypcf_ww_w", (ypcf_ww_w))
printf("done store 4 \n")
st_store(. , "ypcf_wwge", (ypcf_wwge))
printf("done store 5 \n")
st_store(. , "yp_w", (yp_w))
printf("done store 6 \n")

st_store(. , "yp_bb_w", yp_bb_w)
st_store(. , "yp_bvols_w", yp_bvols_w)
printf("done store 1 \n")
st_store(. , "yp_ww_w", yp_ww_w)
printf("done store 2 \n")
st_store(. , "ypcf_bvols_w", (ypcf_bvols_w))
st_store(. , "ypcf_bb_w", (ypcf_bb_w))
printf("done store 3 \n")
st_store(. , "ypcf_ww_w", (ypcf_ww_w))
printf("done store 4 \n")
st_store(. , "ypcf_wwge_w", (ypcf_wwge_w))
printf("done store 5 \n")
st_store(. , "ypcf_w", (ypcf_w))
printf("done store 6 \n")
return(dypcf)

}

struct decomp {
real vector  yp_bb
real vector  r_bb
real vector  r_bb1
real vector  r_bb2
real vector  yp_bvols
real vector  r_bvols
real vector  r_bvols1
real vector  r_bvols2
real vector  r_bvols3
}

function decom  (real matrix Qbb, matrix Qbvols, real matrix Qw, 
	real matrix Z, real matrix Z0,
	real matrix ypt_avw, real matrix sp, real matrix sp_w, real matrix sp_bbt, 
	real matrix D, real matrix b_w,
	real matrix za_t, real matrix za_avw, real matrix za_bb,  real matrix za_bba, 
	real matrix za_w, real matrix za_ww, 
	real matrix zacf_avw, real matrix zacf_bb,  real matrix zacf_bba, 
	real matrix zacf_w, real matrix zacf_ww,
	real matrix thm , real matrix thx, real matrix thxx, 
	real matrix y, real matrix yi ,  real matrix yj,  real vector mu , 
	struct  decomp scalar v )
	
{ 


lspt=log(sp)
lthxm=log(yi)+log(yj)
lsp_bbt=log(sp_bbt)
lsp_w=log(sp_w)
(mean(ypt_avw), mean(lspt), mean(lthxm), mean(lsp_bbt), mean(lsp_w))
norm(ypt_avw- lspt) /* check true trade flows */

/*correct sales and expenditure shares - BB */
/*
e=J(rows(za_bb),1,1)
c_bba=(mean(lspt)-  mean(Qbba*za_t + log(sp_bbt))  ):*e
yp_bba=  (Qbba*za_t+  c_bba+ log(sp_bbt) )
*/

yp_bb=  ( (Qbb*za_t)+log(sp_bbt) )
r_bb=lspt-yp_bb
(mean(lspt-yp_bb), mean(lspt), mean(yp_bb),variance(r_bb))

Pbb=I(rows(Qbb))-Qbb
trace(Pbb+Qbb)

r_bb1=(Pbb*za_t)
r_bb2=(r_bb-r_bb1)
( mean(r_bba), mean(r_bba1),mean(r_bba2),mean(r_bba1+r_bba2))

r_bb1=r_bb1:/r_bb
r_bb2=r_bb2:/r_bb
( mean(r_bb), mean(r_bb1),mean(r_bb2),mean(r_bb1+r_bb2))
printf("done  Bias bb \n")

/*observed sales and expenditur shares - Qbvols */
/*
c_bb=( mean(lspt)- mean(Qbb*za_t+log(yi)+log(yj)) ):*e
yp_bb=  (Qbb*za_t  +c_bb+log(yi)+log(yj) )
*/

yp_bvols=  ( Qbvols*za_t + log(yi)+log(yj) )
r_bvols=lspt-yp_bvols
(mean(lspt-yp_bvols), mean(lspt) , mean(yp_bvols), variance(r_bvols))

Pbvols=I(rows(Qbvols))-Qbvols
trace(Pbvols+Qbvols)

r_bvols1= (log(sp_bbt)-(log(yi)+log(yj)))
r_bvols2=(Qbb-Qbvols)*za_t
r_bvols3=r_bb
(mean(r_bvols), mean(r_bvols1), mean(r_bvols2),mean(r_bvols3) ,mean(r_bvols1+r_bvols2+r_bvols3) )
printf("done  Bias Bvols\n")


r_bvols1 = r_bvols1:/r_bvols
r_bvols2 = r_bvols2:/r_bvols
r_bvols3 = r_bvols3:/r_bvols
(mean(r_bvols), mean(r_bvols1),mean(r_bvols2),mean(r_bvols3), mean(r_bvols1+r_bvols2+r_bvols3) )
printf("done  r_bvols\n")

/*
c_bb=(mean(lspt)- mean(Qbb*za_w+log(yi)+log(yj) )  ) :*e
yp_bb_w=  (Qbb*za_w  +c_bb+log(yi)+log(yj) )
*/
yp_bb_w=  (Qbb*za_w +log(yi)+log(yj) )
(mean(lspt), mean(yp_bb_w))

v.yp_bb=yp_bb
v.r_bb=r_bb
v.r_bb1=r_bb1 
v.r_bb2=r_bb2
v.yp_bvols=yp_bvols
v.r_bvols=r_bvols 
v.r_bvols1=r_bvols1 
v.r_bvols2=r_bvols2 
v.r_bvols3=r_bvols3
 
printf("done decomp \n")
return(v)              

}


struct pass {
real matrix  za
real vector  thphi
real matrix  D
real matrix  yi
real matrix  yj
}

void function avw(real colvector x, real colvector values, struct pass scalar p)
{
values = p.D'*exp( p.za+p.D*x) - p.thphi

/*(1,mean(values), mean(p.za), mean(x))*/

}

/*
struct pass_ge_bb {
real matrix  za
real vector  thphi
real matrix  D
real matrix  Dm
real matrix  Dxx
real matrix  yi
real matrix  yj
real matrix  thxx
real matrix  tlxx
real vector  mu0
real scalar  s
real vector  thm
}

void function avwge_bb(real colvector x, real colvector values, struct pass_ge_bb scalar pge)
{

z= pge.za+pge.D* x
mu=x[$b+1..rows(x),1]
mu=(mu\0)

thxge=exp( (mu-pge.mu0)*(1/(1-pge.s)) ):*pge.tlxx
thxge=thxge/sum(thxge)
thmge=thxge:*(pge.thm:/pge.thxx)

thphige=(thmge \ thxge)
thphige=thphige[1..rows(thphige)-1,1]

values = pge.D'*exp( z) - thphige
}
*/

struct pass_ge {
real matrix  za
real vector  thphi
real matrix  D
real matrix  Dm
real matrix  Dxx
real matrix  thxx
real vector  mu0
real scalar  s
real vector  thm
real matrix  yi
real matrix  yj
}

void function avwge(real colvector x, real colvector values, struct pass_ge scalar pge)
{

z= pge.za+pge.D* x
mu=x[$b+1..rows(x),1]
mu=(mu\0)

thxge=exp( (mu-pge.mu0)*(1/(1-pge.s)) ):*pge.thxx
thxge=thxge/sum(thxge)
thmge=thxge:*(pge.thm:/pge.thxx)

thphige=(thmge \ thxge)
thphige=thphige[1..rows(thphige)-1,1]

values = pge.D'*exp( z) - thphige
}
end
		  
/*
void function avw_ge(real colvector x, real colvector values, struct pass_ge scalar pge)
{
z= pge.za+pge.D* x
/*z= pge.za+pge.D*( x + log(pge.thphi) ) + (pge.Dm,pge.Dxx)*(0*pge.thphi \ log(pge.thxx[$b,1]) )  - log(pge.cf)*/
values = pge.D'*exp( z) - pge.thphi
}
*/
